
% obtem elementos da sequencia de Fibonacci
fibcalc(1, 1):-!.
fibcalc(2, 1):-!.
fibcalc(N, Fib) :-
  N1 is N-1,
  N2 is N-2,
  fibcalc(N1, Fib1),
  fibcalc(N2, Fib2), Fib is Fib1+ Fib2.

:- dynamic(fibonacci_element/2).
:- dynamic(mem_fib/1).
mem_fib(0).

% termina producao de fatos com elementos da sequencia de Fibonacci
produz_fibonacci(Nmax) :-
  mem_fib(N), N > Nmax, 
  retractall(produz_fib_fim(false)), 
  asserta(produz_fib_fim(true)), 
  !, true.

% comeca producao de fatos com elementos da sequencia de Fibonacci
produz_fibonacci(Nmax) :-
  mem_fib(N), N =< Nmax, 
  retract(mem_fib(N)), 
  N1 is N+1, 
  asserta(mem_fib(N1)), 
  fibcalc(N1, Fib), 
  assertz(fibonacci_element(N1, Fib)), 
  produz_fibonacci(Nmax).

% elimina fatos da memoria
clear_fibonacci :- 
  retractall(mem_fib(_)), 
  retractall(fibonacci_element(_,_)), 
  retractall(produz_fib_fim(_)), 
  asserta(mem_fib(0)), 
  asserta(produz_fib_fim(false)).

fibonacci(Nmax, Sequencia):-
  produz_fibonacci(Nmax),
  findall(F, fibonacci_element(_, F), Sequencia), 
  clear_fibonacci.
